' Discogs Music match script to go in "/Scripts" folder of MM3
'
' VERSION V1.0B1
'


Const MyDiscogsAPIKey = "<DISCOGS_APIKEY>" 'put your API key from http://www.discogs.com/help/api

Dim WB, XMLdoc, XMLdoc2, CheckAlbum, CheckArtiste, CheckLabel, CheckYear, CheckTracks, CheckGenre, CheckCountry, Header
Dim FoundLinks
Dim Tmr, Tmr2
Dim ini 
 
' MediaMonkey calls this method whenever a search is started using this script
Sub StartSearch(Panel, SearchTerm, SearchArtist, SearchAlbum)
 
  Set UI = SDB.UI

  Set ini = SDB.IniFile
  If Not (ini Is Nothing) Then
    'We init default settings only if they do not exist in ini file yet
    If ini.StringValue("DiscogsAutoTagWeb","CheckAlbum") = "" Then
      ini.BoolValue("DiscogsAutoTagWeb","CheckAlbum") = true
    End If 
    If ini.StringValue("DiscogsAutoTagWeb","CheckArtiste") = "" Then
      ini.BoolValue("DiscogsAutoTagWeb","CheckArtiste") = true
    End If 
    If ini.StringValue("DiscogsAutoTagWeb","CheckLabel") = "" Then
      ini.BoolValue("DiscogsAutoTagWeb","CheckLabel") = true
    End If 
    If ini.StringValue("DiscogsAutoTagWeb","CheckYear") = "" Then
      ini.BoolValue("DiscogsAutoTagWeb","CheckYear") = true
    End If 
    If ini.StringValue("DiscogsAutoTagWeb","CheckGenre") = "" Then
      ini.BoolValue("DiscogsAutoTagWeb","CheckGenre") = true
    End If 
    If ini.StringValue("DiscogsAutoTagWeb","CheckTracks") = "" Then
      ini.BoolValue("DiscogsAutoTagWeb","CheckTracks") = true
    End If 
    If ini.StringValue("DiscogsAutoTagWeb","CheckCountry") = "" Then
      ini.BoolValue("DiscogsAutoTagWeb","CheckCountry") = true
    End If 

  End If


  ' Create a panel at the top of the window
  Set Header= UI.NewPanel(Panel)
  Header.Common.Align = 1
  Header.Common.Top = 0
  Header.Common.Left = 0
  Header.Common.Height = 30

  Set CheckAlbum = UI.NewCheckBox(Header)
  CheckAlbum.Caption = "Album"
  CheckAlbum.Common.Top = 5
  CheckAlbum.Common.Left = 5
  CheckAlbum.Checked = ini.BoolValue("DiscogsAutoTagWeb","CheckAlbum")

  Set CheckArtiste = UI.NewCheckBox(Header)
  CheckArtiste.Caption = "Artiste Name"
  CheckArtiste.Common.Top = 5
  CheckArtiste.Common.Left = 150
  CheckArtiste.Checked = ini.BoolValue("DiscogsAutoTagWeb","CheckArtiste")

  Set CheckLabel = UI.NewCheckBox(Header)
  CheckLabel.Caption = "Label"
  CheckLabel.Common.Top = 5
  CheckLabel.Common.Left = 300
  CheckLabel.Checked = ini.BoolValue("DiscogsAutoTagWeb","CheckLabel")

  Set CheckYear = UI.NewCheckBox(Header)
  CheckYear.Caption = "Release year"
  CheckYear.Common.Top = 5
  CheckYear.Common.Left = 450
  CheckYear.Checked = ini.BoolValue("DiscogsAutoTagWeb","CheckYear")

  Set CheckGenre = UI.NewCheckBox(Header)
  CheckGenre.Caption = "Genre"
  CheckGenre.Common.Top = 5
  CheckGenre.Common.Left = 600
  CheckGenre.Checked = ini.BoolValue("DiscogsAutoTagWeb","CheckGenre")

  Set CheckTracks = UI.NewCheckBox(Header)
  CheckTracks.Caption = "Tracks"
  CheckTracks.Common.Top = 5
  CheckTracks.Common.Left = 750
  CheckTracks.Checked = ini.BoolValue("DiscogsAutoTagWeb","CheckTracks")

  Set CheckCountry = UI.NewCheckBox(Header)
  CheckCountry.Caption = "Country"
  CheckCountry.Common.Top = 5
  CheckCountry.Common.Left = 900
  CheckCountry.Checked = ini.BoolValue("DiscogsAutoTagWeb","CheckCountry")

  Script.RegisterEvent CheckAlbum.Common, "OnClick", "ResultFullyLoaded"
  Script.RegisterEvent CheckArtiste.Common, "OnClick", "ResultFullyLoaded"
  Script.RegisterEvent CheckGenre.Common, "OnClick", "ResultFullyLoaded"
  Script.RegisterEvent CheckLabel.Common, "OnClick", "ResultFullyLoaded"
  Script.RegisterEvent CheckTracks.Common, "OnClick", "ResultFullyLoaded"
  Script.RegisterEvent CheckYear.Common, "OnClick", "ResultFullyLoaded"
  Script.RegisterEvent CheckCountry.Common, "OnClick", "ResultFullyLoaded"

  ' This is a web browser that we use to present results to the user
  Set WB = UI.NewActiveX(Panel, "Shell.Explorer")
  WB.Common.Align = 5      ' Fill whole client rectangle
  WB.Common.ControlName = "WB"
  WB.Common.Top = 35
  WB.Common.Left = 0

  Set WBIntf = WB.Interf
  WBIntf.Visible = false


  ' This is a hidden browser hat we use to find results (a better solution can be used, but this seems to be the easiest...)
  Set XMLdoc = CreateObject("Microsoft.XMLDOM")

  SrchTxt = SearchTerm
  If SearchAlbum <> "" Then
    SrchTxt = SearchAlbum
    SrchType = "releases"  ' Search for a releases - all - artists
  Else
    If SearchArtist <> "" Then
       SrchTxt = SearchArtist
       SrchType = "artists"  ' Search for a releases - all - artists
    Else
       SrchTxt = SearchTerm
       SrchType = "all"  ' Search for a releases - all - artists
    End If
  End If
  SrchType = "all"
 'MsgBox SearchTerm

  XMLdoc.Load("http://www.discogs.com/search?type=" & SrchType & "&q=" & SrchTxt & "&f=xml&api_key=" & MyDiscogsAPIKey )
 
  Set Tmr = SDB.CreateTimer(40)
  Script.RegisterEvent Tmr, "OnTimer", "ContinueSearch"

End Sub



 
' We use this procedure as a callback using Timer, so that we can present results as soon as they are downloaded
Sub ContinueSearch(Timer)

  Script.UnregisterEvents Tmr
  Set Tmr = Nothing
 
  If XMLdoc.xml = "" then       ' A trick - wait until navigation to the search results page starts
    Set Tmr = SDB.CreateTimer(40)
    Script.RegisterEvent Tmr, "OnTimer", "ContinueSearch"
    Exit Sub
  End If
 
  Set elemList = XMLdoc.selectSingleNode("/resp") 'xmlNodeList

  Set DivResults = XMLdoc.selectSingleNode("/resp/searchresults")
 
  Set Results = SDB.NewStringList
  Set FoundLinks = SDB.NewStringList
  If DivResults.xml <> "" Then
    Set AColl = DivResults.selectNodes("result")
    For Each itm In AColl
      if (itm.selectSingleNode("@type").text = "release" ) then
          Set Links = itm.selectSingleNode("uri")
          Set Summary = itm.selectSingleNode("title")
          Results.Add Summary.Text
          FoundLinks.Add Links.Text
      End If
    Next
 
    SDB.Tools.WebSearch.SetSearchResults Results
    If Results.Count > 0 Then
      SDB.Tools.WebSearch.ResultIndex = 0
    End If
  Else
    WB.SetHTMLDocument = XMLdoc.xml
    Set WBIntf = WB.Interf
    WBIntf.Visible = true
  End If
End Sub
 



' This procedure is called by MediaMonkey when user selects some of search results
Sub ShowResult(ResultID)
  If ResultID >= 0 And ResultID < FoundLinks.Count Then
    WB.SetHTMLDocument ""                 ' To prevent usage of this data
    WB.Interf.Navigate FoundLinks.Item(ResultID)
    Set Tmr2 = SDB.CreateTimer(500)
    Script.RegisterEvent Tmr2, "OnTimer", "FormatSearchResultsViewer"

    Set XMLdoc2 = CreateObject("Microsoft.XMLDOM")
    XMLdoc2.Load(FoundLinks.Item(ResultID) & "?f=xml&api_key=" & MyDiscogsAPIKey )
 
    Set Tmr = SDB.CreateTimer(500)
    Script.RegisterEvent Tmr, "OnTimer", "ResultFullyLoaded"
  End If
End Sub
 



' This is a callback handled by a timer, so that we can respond as soon as album results are loaded
Sub ResultFullyLoaded(Timer)
  Script.UnregisterEvents Tmr
  Set Tmr = Nothing
 
  Set Tracks = SDB.NewStringList
  Set ArtistTitle = SDB.NewStringList

  SDB.Tools.WebSearch.ClearTracksData   ' Tell MM to disregard any previously set tracks' data
 
  Dim theRelease : Set theRelease = XMLdoc2.selectSingleNode("/resp/release") 'xmlNodeList
 
  If XMLdoc2.xml <> "" And theRelease.xml <> "" Then

    ' Get artist title
   
    If Not theRelease.selectSingleNode("artists/artist/anv") is Nothing Then
      Set itm = theRelease.selectSingleNode("artists/artist/anv") 'pseudo de l'album
    Else
      Set itm = theRelease.selectSingleNode("artists/artist/name") 'Nom de prod
    End If
    
    AlbumArtistTitle = itm.Text


    ' Get track titles and track artists
    Set trackList = theRelease.selectNodes("tracklist/track")

    For Each itm In trackList
      Set trackNum = itm.selectSingleNode("position")
      If trackNum.Text <> "" Then
        Set trackName = itm.selectSingleNode("title")
        tmpTrack = trackName.Text
        myList = ""
        For Each items In itm.selectNodes("extraartists/artist")
          if items.selectSingleNode("role").Text = "Featuring" Then
           if myList = "" Then
             myList = " (Feat. " & items.selectSingleNode("name").Text
            Else
             myList = myList & ", " & items.selectSingleNode("name").Text
            End If
          End If
        Next
        If myList <> "" Then
           Tracks.Add tmpTrack & myList & ")"
        Else
           Tracks.Add tmpTrack
        End If

        Set trackArtistList = itm.selectNodes("artists/artist")
        If trackArtistList.length > 0 Then
          MyList = ""
          For Each itm2 In trackArtistList
            If MyList <> "" Then MyList = MyList & ", " End If
            MyList = MyList & itm2.selectSingleNode("name").Text
          Next
          ArtistTitle.Add MyList
        Else
          ArtistTitle.Add AlbumArtistTitle
        End If
      End If
    Next

 
    ' Get album title
    Set itm = theRelease.selectSingleNode("title")
    AlbumTitle = itm.Text

 
    ' Get Album art URL
    Set imgs = theRelease.selectNodes("images/image")
    if imgs.length > 0 Then
      Set itm1 = imgs.Item(0)
      SDB.Tools.WebSearch.AlbumArtURL = itm1.selectSingleNode("@uri").Text
    End If


    ' Get release year
    Set itm = theRelease.selectSingleNode("released")
    If Not (itm Is Nothing) Then 
     If Len(itm.Text) > 3 Then 
      ReleaseYear = Left(itm.Text, 4) 
     Else 
      ReleaseYear = "" 
     End If 
    Else 
     ReleaseYear = "" 
    End If


     ' Get genres
    Set itm = theRelease.selectSingleNode("genres/genre")
    Genres = itm.Text

    ' Get styles/moods/themes
    Set theStyles = theRelease.selectNodes("styles/style")
    MyList = ""
    For Each itm In theStyles
      If MyList <> "" Then MyList = MyList & ", " End If
      MyList = MyList & itm.Text
    Next
    Styles = MyList

    ' Get Label
    MyList = ""
    For Each itm In theRelease.selectNodes("labels/label")
      If MyList <> "" Then MyList = MyList & ", " End If
      MyList = MyList & itm.selectSingleNode("@name").Text
    Next
    theLabels = MyList

    ' Get Country
    Set itm = theRelease.selectSingleNode("country")
    If Not (itm Is Nothing) Then theCountry = itm.Text Else theCountry = "" End If

 End if

  If Tracks.Count = 0 Then
    ' Nothing found yet, wait some more time
    Set Tmr = SDB.CreateTimer(500)
    Script.RegisterEvent Tmr, "OnTimer", "ResultFullyLoaded"
  Else
    ' Some results were found, notify MediaMonkey
    If Not CheckTracks.Checked Then 
     Set Tracks = SDB.NewStringList
     Set ArtistTitle = SDB.NewStringList
     For sIdx = 0 To SDB.SelectedSongList.Count - 1
     	Tracks.Add SDB.SelectedSongList.Item(sIdx).Title
        ArtistTitle.Add SDB.SelectedSongList.Item(sIdx).ArtistName
     Next
  End If

    SDB.Tools.WebSearch.SmartUpdateTracks Tracks

    For i = 0 To SDB.Tools.WebSearch.NewTracks.Count - 1
      If CheckArtiste.Checked Then SDB.Tools.WebSearch.NewTracks.Item(i).ArtistName = AlbumArtistTitle
      For j = 0 To Tracks.Count - 1
       If Tracks.Item(j) = SDB.Tools.WebSearch.NewTracks.Item(i).Title And CheckArtiste.Checked Then
        If CheckArtiste.Checked Then SDB.Tools.WebSearch.NewTracks.Item(i).ArtistName = ArtistTitle.Item(j)
        If CheckTracks.Checked Then SDB.Tools.WebSearch.NewTracks.Item(i).TrackOrder = j+1
       End If
      Next
      If CheckArtiste.Checked Then SDB.Tools.WebSearch.NewTracks.Item(i).AlbumArtistName = AlbumArtistTitle
      If CheckAlbum.Checked Then SDB.Tools.WebSearch.NewTracks.Item(i).AlbumName = AlbumTitle 
      If ReleaseYear <> "" And CheckYear.Checked Then SDB.Tools.WebSearch.NewTracks.Item(i).Year = ReleaseYear
      If CheckGenre.Checked Then SDB.Tools.WebSearch.NewTracks.Item(i).Genre = Genres
      If CheckGenre.Checked Then SDB.Tools.WebSearch.NewTracks.Item(i).Custom1 = Styles
      If CheckLabel.Checked Then SDB.Tools.WebSearch.NewTracks.Item(i).Custom2 = theLabels
      If CheckCountry.Checked Then SDB.Tools.WebSearch.NewTracks.Item(i).Custom3 = theCountry
    Next
    SDB.Tools.WebSearch.RefreshViews   ' Tell MM that we have made some changes
  End If
End Sub


' This does the final clean up, so that our script doesn't leave any unwanted traces
Sub FinishSearch(Panel)
  ' save checkBoxes if ini exists
  If Not (ini Is Nothing) Then
    ini.BoolValue("DiscogsAutoTagWeb","CheckAlbum") = CheckAlbum.Checked
    ini.BoolValue("DiscogsAutoTagWeb","CheckArtiste") = CheckArtiste.Checked
    ini.BoolValue("DiscogsAutoTagWeb","CheckLabel") = CheckLabel.Checked
    ini.BoolValue("DiscogsAutoTagWeb","CheckYear") = CheckYear.Checked
    ini.BoolValue("DiscogsAutoTagWeb","CheckGenre") = CheckGenre.Checked
    ini.BoolValue("DiscogsAutoTagWeb","CheckTracks") = CheckTracks.Checked
    ini.BoolValue("DiscogsAutoTagWeb","CheckCountry") = CheckCountry.Checked
  End If
  

  ' Correctly terminate all the actions we have started
  Script.UnRegisterEvents CheckAlbum
  Script.UnRegisterEvents CheckArtiste
  Script.UnRegisterEvents CheckYear
  Script.UnRegisterEvents CheckGenre
  Script.UnRegisterEvents CheckLabel
  Script.UnRegisterEvents CheckTracks
  Script.UnRegisterEvents CheckCountry

  CheckAlbum.Common.DestroyControl      ' Destroy the external control
  Set CheckAlbum = Nothing              ' Release global variable
  CheckArtiste.Common.DestroyControl      ' Destroy the external control
  Set CheckArtiste = Nothing              ' Release global variable
  CheckGenre.Common.DestroyControl      ' Destroy the external control
  Set CheckGenre = Nothing              ' Release global variable
  CheckTracks.Common.DestroyControl      ' Destroy the external control
  Set CheckTracks = Nothing              ' Release global variable
  CheckYear.Common.DestroyControl      ' Destroy the external control
  Set CheckYear = Nothing              ' Release global variable
  CheckLabel.Common.DestroyControl      ' Destroy the external control
  Set CheckLabel = Nothing              ' Release global variable
  CheckCountry.Common.DestroyControl      ' Destroy the external control
  Set CheckCountry = Nothing              ' Release global variable

  WB.Common.DestroyControl      ' Destroy the external control
  Set WB = Nothing              ' Release global variable

  'Header.Common.DestroyControl      ' Destroy the external control
  'Set Header = Nothing              ' Release global variable

  Set ini = Nothing
  Set XMLdoc = Nothing             '    "      "        "
  Set XMLdoc2 = Nothing             '    "      "        "
  Set FoundLinks = Nothing      '    "      "        "
  If IsObject(Tmr) Then
    Script.UnregisterEvents Tmr ' Unregister timer events
    Set Tmr = Nothing           ' Release global variable
  End If
  If IsObject(Tmr2) Then
    Script.UnregisterEvents Tmr2 ' Unregister timer events
    Set Tmr2 = Nothing           ' Release global variable
  End If
End Sub


' We use this procedure as a callback using Timer, so that we can reformat results as soon as they are downloaded
Sub FormatSearchResultsViewer(Timer)
  Script.UnregisterEvents Tmr2
  Set Tmr2 = Nothing

  Set WBIntf = WB.Interf
  WBIntf.Visible = false
 
  If Len(WBIntf.LocationURL) < 10 Then        ' A trick - wait until navigation to the search results page starts
    Set Tmr2 = SDB.CreateTimer(40)
    Script.RegisterEvent Tmr2, "OnTimer", "FormatSearchResultsViewer"
    Exit Sub
  End If
 
  If WBIntf.ReadyState = 1 Or WBIntf.Busy Then
    Set Tmr2 = SDB.CreateTimer(40)
    Script.RegisterEvent Tmr2, "OnTimer", "FormatSearchResultsViewer"
    Exit Sub
  End If

  Set Doc2 = WBIntf.Document
  Set DivResults = Doc2.body
  tmpHTML = Doc2.documentElement.innerHTML
 
  If tmpHTML <> "" Then
    pos1 = InStr(LCase(tmpHTML), "releasetitle")
    pos2 = InStr(pos1-100, LCase(tmpHTML), "<table")
   
    tmpHTML = Mid( CStr(tmpHTML), pos2 )
    pos1 = InStr( LCase(tmpHTML), "tracklisting")
    pos2 = InStr(pos1, LCase(tmpHTML), "</table>") + 9

    tmpHTML = Left( CStr(tmpHTML) , pos2)
    tmpHTML = "<style type=text/css> * { font-size: 0.95em;}</style>" & tmpHTML
    WB.SetHTMLDocument tmpHTML
  End If

  WBIntf.Visible = true
End Sub 